//========================================================================================
//
//	File:				FWContnt.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWCONTNT_H
#define FWCONTNT_H

#ifndef FWPRTDEF_H
#include "FWPrtDef.h"
#endif

// ----- Foundation Includes -----

#ifndef FWSTDDEF_H
#include "FWStdDef.h"
#endif

#ifndef FWRUNTYP_H
#include "FWRunTyp.h"
#endif

// ----- OpenDoc Includes -----

#ifndef _ODTYPES_
#include <ODTypes.h>
#endif

//========================================================================================
//	Forward Declarations
//========================================================================================

class ODStorageUnit;

class FW_CPart;
class FW_CCloneInfo;
class FW_CPromise;
class FW_CFrame;
class ODShape;

//========================================================================================
//	class FW_CContent
//========================================================================================

class FW_CContent
{
//----------------------------------------------------------------------------------------
//	Initialization/Destruction
//
  public:	
	FW_CContent(Environment* ev, FW_CPart* part);
	virtual ~FW_CContent();

//----------------------------------------------------------------------------------------
//	Public API
//
public:
	virtual void					Externalize(Environment* ev,
											ODStorageUnit* storageUnit,
											FW_EStorageKinds storageKind,
											FW_CCloneInfo* cloneInfo);
	virtual FW_Boolean				Internalize(Environment* ev,
											ODStorageUnit* storageUnit, 
											FW_EStorageKinds storageKind,
											FW_CCloneInfo* cloneInfo);

	virtual void					ReleaseAll(Environment *ev);

	// ----- Shape of the data -----
	virtual ODShape*				CreateDataFrameShape(Environment* ev) const;
	
	// ----- Getters -----
	FW_CPart*						GetPart(Environment* ev) const;
	
//----------------------------------------------------------------------------------------
//	Data Members
//
private:
	FW_CPart*						fPart;
};

//========================================================================================
//	Inlines
//========================================================================================

//----------------------------------------------------------------------------------------
//	FW_CContent::GetPart
//----------------------------------------------------------------------------------------
inline FW_CPart* FW_CContent::GetPart(Environment*) const
{
	return fPart;
}


#endif