//========================================================================================
//
//	File:				FWContng.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWINTRNG_H
#define FWINTRNG_H

#ifndef FWINTER_H
#include "FWInter.h"
#endif

//========================================================================================
//	Forward Declarations
//========================================================================================

class ODStorageUnit;
class ODPasteAsResult;
class ODShape;

class FW_CEmbeddingPart;
class FW_CCloneInfo;
class FW_MProxy;
class FW_CEmbeddingContent;
class FW_CPresentation;

//========================================================================================
//	class FW_CEmbeddingDataInterchange
//========================================================================================

class FW_CEmbeddingDataInterchange : public FW_CDataInterchange
{
//----------------------------------------------------------------------------------------
//	Initialization/Destruction
//
public:	
	FW_CEmbeddingDataInterchange(Environment* ev, FW_CEmbeddingPart* part);
	virtual ~FW_CEmbeddingDataInterchange();

//----------------------------------------------------------------------------------------
//	Externalize/Internalize
//
public:	
	virtual void					DoExternalizeSingleEmbeddedFrame(Environment* ev, 
										ODFrame* odEmbeddedFrame,
										ODStorageUnit* destinationSU, 
										FW_CCloneInfo* cloneInfo);
	virtual FW_EInternalizeResult	DoInternalizeSingleEmbeddedFrame(Environment* ev, 
										ODStorageUnit* sourceSU, 
										FW_CCloneInfo* cloneInfo);

//----------------------------------------------------------------------------------------
//	For Internal Use Only
//
public:
	// ----- Externalize/Internalize -----
	virtual void					PrivHandleExternalizeData(Environment* ev, 
										FW_CContent* content,
										ODStorageUnit* storageUnit,
										FW_EStorageKinds storageKind, 
										FW_CCloneInfo* cloneInfo);
										
	virtual FW_EInternalizeResult	PrivHandleInternalizeData(Environment* ev, 
										FW_CContent* content,
										ODStorageUnit* storageUnit,
										FW_EStorageKinds storageKind, 
										FW_CCloneInfo* cloneInfo);

	virtual void					PrivPostInternalizeData(Environment* ev, 
										FW_CContent* content,
										FW_CCloneInfo* cloneInfo,
										FW_EInternalizeResult result);

protected:
	ODShape*						PrivReadFrameShape(Environment* ev, 
										ODStorageUnit* sourceSU);
	
	void							PrivPostInternalizeContent(Environment* ev, 
										FW_CCloneInfo* cloneInfo);								
	void							PrivPostInternalizeFrame(Environment* ev, 
										FW_CEmbeddingContent* content, 
										FW_CCloneInfo* cloneInfo,
										ODTypeToken viewAs);								
	void							PrivPostInternalizePart(Environment* ev, 
										FW_CEmbeddingContent* content, 
										FW_CCloneInfo* cloneInfo,
										ODTypeToken viewAs);								

	FW_EInternalizeResult			PrivClonePart(Environment* ev,
										ODStorageUnit* sourceSU,
										FW_CCloneInfo* cloneInfo);

	virtual FW_EInternalizeResult	PrivHandleEmbedAs(Environment* ev, 
										FW_CContent* content,
										ODStorageUnit* sourceSU,
										FW_CCloneInfo* cloneInfo,
										ODPasteAsResult* embedAsInfo);						
	FW_EInternalizeResult			PrivPostEmbedAs(Environment* ev, 
										FW_CContent* content,
										ODStorageUnit* sourceSU,
										FW_CCloneInfo* cloneInfo,
										ODPasteAsResult* embedAsInfo);						

private:
	FW_CPresentation*				GetPresentation(Environment* ev, FW_CCloneInfo* cloneInfo);
};


#endif
