//========================================================================================
//
//	File:				FWPrstng.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWPRSTNG_H
#define FWPRSTNG_H

#ifndef FWPRESEN_H
#include "FWPresen.h"
#endif

//========================================================================================
//	Forward Declarations
//========================================================================================

class ODShape;
class ODPart;
class ODFrame;

class FW_CEmbeddingPart;
class FW_CSelection;
class FW_MProxy;

//========================================================================================
//	class FW_CEmbeddingPresentation
//========================================================================================

class FW_CEmbeddingPresentation : public FW_CPresentation
{
//----------------------------------------------------------------------------------------
//	Constructors/Destructors
//
public:
	FW_CEmbeddingPresentation(Environment *ev, 
					FW_CEmbeddingPart* thePart, 
					FW_CSelection* selection, 
					ODTypeToken presentationType,
					ODTypeToken defaultEmbeddedFrameViewType = FW_CPart::gViewAsFrameToken);
	virtual ~FW_CEmbeddingPresentation();

//----------------------------------------------------------------------------------------
//	Inerited API
//
public:
	// ----- Embedding -----
	void				Embed(Environment* ev, 
							ODPart* embeddedPart,			// Might be null
							ODFrame* embeddedFrame,			// Might be null
							ODType suggestedFrameType,		// force to the type of embeddedFrame if != NULL
							FW_MProxy* proxy,
							ODShape* frameShape,
							ODTypeToken viewType,
							ODTypeToken presentationType,
							ODID frameGroupID,
							FW_Boolean isOverlaid,
							FW_Boolean subFrame);
};

#endif